package com.shanghaichengdi.ghjgitem.controller;

import com.alibaba.fastjson.JSONObject;
import com.shanghaichengdi.ghjgitem.constant.HttpStatus;
import com.shanghaichengdi.ghjgitem.domain.BoatWaterPollutantWarningS;
import com.shanghaichengdi.ghjgitem.domain.ShorePowerConnRecordInfo;
import com.shanghaichengdi.ghjgitem.service.ShorePowerConnRecordInfoService;
import com.shanghaichengdi.ghjgitem.util.CommonTools;
import com.shanghaichengdi.ghjgitem.vo.ObjectBodyVo;
import com.shanghaichengdi.ghjgitem.vo.SyncVo;
import com.shanghaichengdi.ghjgitem.vo.request.PollutantWarningInfoReq;
import com.shanghaichengdi.ghjgitem.vo.response.ResultRes;
import com.shanghaichengdi.ghjgitem.vo.response.ReturnMsg;
import java.util.List;
import javax.annotation.Resource;
import lombok.extern.slf4j.Slf4j;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@CrossOrigin
@RequestMapping("/shorePower")
@Slf4j
public class ShorePowerController extends CommonController {

  @Resource
  private ShorePowerConnRecordInfoService connRecordInfoService;

  @PostMapping("/getConnRecordInfoListSync")
  public ReturnMsg getConnRecordInfoListSync(@RequestBody @Validated ObjectBodyVo vo) {
    if (!checkDbKey(vo.getKey())) {
      return ReturnMsg.error(HttpStatus.BAD_REQUEST, "key值有误,请确认您输入的key值正确!");
    }
    String paramJsonData = getParamJsonData(vo.getData());
    SyncVo syncVo = JSONObject.parseObject(paramJsonData, SyncVo.class);
    List<ShorePowerConnRecordInfo> voList = connRecordInfoService.selectConnRecordInfoListSync(
        syncVo);
    ResultRes resultRes = ResultRes.encapsulationResult(syncVo.getPageIndex(),
        syncVo.getPageSize(),
        CommonTools.getTotal(voList), voList);
    String jsonString = JSONObject.toJSONString(resultRes);
    String encodedData = resultEncode(jsonString);
    return ReturnMsg.success("获取成功", encodedData);
  }
}
